unit uUNOPrintJobListener;
{                                                                             |
    Part of ActiveX Library dllOpenOfficeAutomation.dpr                       |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See dllOpenOfficeAutomation.dpr for full copyright notice.                |
|                                                                             }

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
    ComObj, ActiveX, StdVcl,Dialogs,
    dllOpenOfficeAutomation_TLB;

type
 TUNOPrintJobListener
 =
  class(TAutoObject, IUNOPrintJobListener)
  private
    FLastState: Integer;
  protected
    procedure disposing(Source: OleVariant); safecall;
    procedure printJobEvent(Event: OleVariant); safecall;
    function Get_LastState: Integer; safecall;
  public
    procedure AfterConstruction; override;
  end;

implementation

uses ComServ;

procedure TUNOPrintJobListener.AfterConstruction;
begin
     inherited;
     FLastState:= -1;
end;

procedure TUNOPrintJobListener.disposing(Source: OleVariant);
begin
     FLastState:= -1;
end;

procedure TUNOPrintJobListener.printJobEvent(Event: OleVariant);
begin
     FLastState:= Event.State;
end;

function TUNOPrintJobListener.Get_LastState: Integer;
begin
     Result:= FLastState;
end;

initialization
  TAutoObjectFactory.Create(ComServer, TUNOPrintJobListener, Class_UNOPrintJobListener,
    ciMultiInstance, tmSingle);
end.
