unit utcOOoTestCase;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils, Classes, DB, DBClient,
  TestFrameWork,
  uOOoSurTitre;

type
 TtcOOoTestCase
 =
  class( TTestCase)
  protected
    cd: TClientDataset;
    OOoSurTitre: TOOoSurTitre;
    procedure Cree_dataset_interne( _cd: TClientDataset; _cd_Name: String);
    procedure Cree_dataset;
    procedure Detruit_Dataset;
  end;

implementation

{ TtcOOoTestCase }

procedure TtcOOoTestCase.Cree_dataset_interne( _cd: TClientDataset; _cd_Name: String);
var
   Numero, Code, Colonne3, Colonne4, Colonne5: TField;
   I: Integer;
   sI, Ligne_sI: String;
begin
     _cd.Name:= _cd_Name;
     _cd.FieldDefs.Add( _cd_Name+'_Numero'  , ftAutoInc);
     _cd.FieldDefs.Add( _cd_Name+'_Code'    , ftString, 42);
     _cd.FieldDefs.Add( _cd_Name+'_Colonne3', ftString, 42);
     _cd.FieldDefs.Add( _cd_Name+'_Colonne4', ftString, 42);
     _cd.FieldDefs.Add( _cd_Name+'_Colonne5', ftString, 42);

     _cd.CreateDataSet;
     Numero  := _cd.FieldByName(_cd_Name+'_Numero');
     Code    := _cd.FieldByName(_cd_Name+'_Code');
     Colonne3:= _cd.FieldByName(_cd_Name+'_Colonne3');
     Colonne4:= _cd.FieldByName(_cd_Name+'_Colonne4');
     Colonne5:= _cd.FieldByName(_cd_Name+'_Colonne5');
     Numero  .DisplayLabel:= _cd_Name+' - Les numros';
     Code    .DisplayLabel:= _cd_Name+' - Les codes'  ;
     Colonne3.DisplayLabel:= _cd_Name+' - La colonne 3';
     Colonne4.DisplayLabel:= _cd_Name+' - La colonne 4';
     Colonne5.DisplayLabel:= _cd_Name+' - La colonne 5';
     for I:= 0 to 42
     do
       begin
       sI:= IntToStr(I);
       Ligne_sI:= 'Ligne '+sI;
       _cd.Append;
       Numero  .AsString:= sI;
       Code    .AsString:= Ligne_sI;
       Colonne3.AsString:= Ligne_sI;
       Colonne4.AsString:= Ligne_sI;
       Colonne5.AsString:= Ligne_sI;
       _cd.Post;
       end;
end;

procedure TtcOOoTestCase.Cree_dataset;
begin
     Cree_dataset_interne( cd, 'cd');
     OOoSurTitre
     :=
       TOOoSurTitre.Create( ['Les colonnes 3,4,5'],
                            [2],
                            [4]);
end;

procedure TtcOOoTestCase.Detruit_Dataset;
begin
     FreeAndNil( OOoSurTitre);
     FreeAndNil( cd);
end;

end.
