unit utcDeskTop;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils,
  uUNO_DeskTop,
  TestFrameWork;

type
  TDeskTopTests = class(TTestCase)
  private
  protected

//    procedure SetUp; override;
//    procedure TearDown; override;

  published

    // Test methods
    procedure TestCreateWriter;
    procedure TestCreateCalc;
    procedure TestOpenFile;
    procedure TestOpenFile_Modele;
  end;

implementation

{ TDeskTopTests }

procedure TDeskTopTests.TestCreateWriter;
begin
     UNO_DeskTop.CreateWriter;
end;

procedure TDeskTopTests.TestCreateCalc;
begin
     UNO_DeskTop.CreateCalc;
end;

procedure TDeskTopTests.TestOpenFile;
var
   NomFichier: String;
   F: Variant;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'ModeleTest.ott';
     Check( FileExists( NomFichier),
            'Le fichier de test doit tre cr au pralable'#13#10+NomFichier);
     F:= UNO_DeskTop.OpenFile( NomFichier, False, False);
     F.Dispose;
end;

procedure TDeskTopTests.TestOpenFile_Modele;
var
   NomFichier: String;
   F: Variant;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'ModeleTest.ott';
     Check( FileExists( NomFichier),
            'Le fichier de test doit tre cr au pralable'#13#10+NomFichier);
     F:= UNO_DeskTop.OpenFile( NomFichier, False, True);
     F.Dispose;
end;

initialization
              TestFramework.RegisterTest('utcDeskTop Suite',TDeskTopTests.Suite);

end.
