unit uDeskTop;
{                                                                             |
    Part of package pOpenOffice                                               |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr> http://www.mars42.com    |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
                                                                              |
    See pOpenOffice.dpk for full copyright notice.                            |
|                                                                             }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComObj, Variants,

  uServiceManager,

  uUNO_Object,

  uPropertyValue;

type
 TDeskTop
 =
  class( TUNO_Object)
  public
    constructor Create;
    function LoadComponentFromURL( URL, TargetFrameName: String;
                                   SearchFlags: LongInt;
                                   Arguments: Variant): Variant;
    function CreateDocument( URL: String; ReadOnly: Boolean): Variant;
    function OpenFile( FileName: String;  ReadOnly: Boolean): Variant;
    function CreateWriter: Variant;
    function CreateCalc  : Variant;
    function URL_from_WindowsFileName( FileName: String): String;
  end;

var
   DeskTop: TDeskTop;

implementation

{ TDeskTop }

constructor TDeskTop.Create;
begin
     UNO_ClassName:= 'com.sun.star.frame.Desktop';
     inherited Create;
end;

function TDeskTop.LoadComponentFromURL( URL, TargetFrameName: String;
                                        SearchFlags: Integer;
                                        Arguments: Variant): Variant;
begin
     Result:= ole.LoadComponentFromURL( URL, TargetFrameName,
                                        SearchFlags, Arguments);
end;

function TDeskTop.CreateDocument( URL: String; ReadOnly: Boolean): Variant;
var
   LoadParams: Variant;
   PropertyValue: TPropertyValue;
begin
     if ReadOnly
     then
         begin
         LoadParams:= VarArrayCreate([0, 0], varVariant);

         PropertyValue:= TPropertyValue.Create;
         try
            PropertyValue[ 'ReadOnly']:= True;

            LoadParams[0]:= PropertyValue.ole;
         finally
                FreeAndNil( PropertyValue);
                end;
         end
     else
         LoadParams:= VarArrayCreate([0, -1], varVariant);
     Result:= LoadComponentFromURL( URL, '_blank', 0, LoadParams);
end;

function TDeskTop.OpenFile( FileName: String; ReadOnly: Boolean): Variant;
var
   URL: String;
begin
     URL:= URL_from_WindowsFileName( FileName);
     Result:= CreateDocument( URL, ReadOnly);
end;

function TDeskTop.CreateWriter: Variant;
begin
     Result:= CreateDocument( 'private:factory/swriter', False);
end;

function TDeskTop.CreateCalc: Variant;
begin
     Result:= CreateDocument( 'private:factory/scalc' , False);
end;

function TDeskTop.URL_from_WindowsFileName(FileName: String): String;
var
   I: Integer;
begin
     Result:= FileName;
     for I:= 0 to Length( Result)
     do
       if Result[I]= '\'
       then
           Result[I]:= '/';
     Result:= 'file:///'+Result;
end;

initialization
              DeskTop:= TDeskTop.Create;
finalization
              FreeAndNil( DeskTop);
end.
