unit uServiceManager;
{                                                                             |
    Part of package pOpenOffice                                               |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr> http://www.mars42.com    |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
                                                                              |
    See pOpenOffice.dpk for full copyright notice.                            |
|                                                                             }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComObj, Variants, ActiveX,

  uOpenOfficeLog;

type
 TServiceManager
 =
  class
  public
    ole: Variant;
    Connected: Boolean;
    constructor Create;
    destructor Destroy; override;

    function Connect: Boolean;
    procedure Disconnect;

    function CreateInstance( UNO_ClassName: String): Variant;
  end;

var
   ServiceManager: TServiceManager = nil;

implementation

{ TServiceManager }

constructor TServiceManager.Create;
begin
     inherited Create;
     Connected:= False;
     Disconnect;
end;

destructor TServiceManager.Destroy;
begin
     Disconnect;
     inherited;
end;

function TServiceManager.Connect: Boolean;
const
     ServiceManager_OLE_Classname= 'com.sun.star.ServiceManager';
var
   MessageException: String;
begin
     if VarIsEmpty( ole)
     then
         try
            ole:= CreateOleObject(ServiceManager_OLE_Classname);
         except
               on E: Exception
               do
                 begin
                 MessageException
                 :=
                   'pOpenOffice.bpl :: TServiceManager.Connect: '+
                   'Impossible de crer un objet '+ServiceManager_OLE_Classname+#13#10+
                   'Message de l''exception: '#13#10+
                   E.Message;
                 OpenOfficeLog.Entree( MessageException);
                 //MessageBox( 0, PChar( MessageException), 'Erreur', MB_ICONERROR or MB_OK);
                 //raise;
                 ole:= Null;
                 end;
               end;

     Connected:= not ( VarIsEmpty(ole) or VarIsNull (ole) );
     Result:= Connected;
     if not Result
     then
         OpenOfficeLog.Entree( 'Echec de TServiceManager.Connect');
end;

procedure TServiceManager.Disconnect;
begin
     VarClear( ole);
     Connected:= False;
end;

function TServiceManager.CreateInstance( UNO_ClassName: String): Variant;
var
   MessageException: String;
begin
     VarClear( Result);
     if not Connected then exit;

     try
        Result:= ole.CreateInstance( UNO_ClassName);
     except
           on E: Exception
           do
             begin
             MessageException
             :=
               'pOpenOffice.bpl :: TServiceManager.CreateInstance: '+
               'Impossible de crer un objet UNO '+UNO_ClassName+#13#10+
               'Message de l''exception: '#13#10+
               E.Message;
             OpenOfficeLog.Entree( MessageException);
             MessageBox( 0, PChar( MessageException), 'Erreur', MB_ICONERROR or MB_OK);
             raise;
             end;
           end;
     if    VarIsEmpty( Result)
        or VarIsNull ( Result)
        or VarIsClear( Result)
     then
         OpenOfficeLog.Entree( 'Echec de TServiceManager.CreateInstance');
end;

initialization
              CoInitialize( nil);
              ServiceManager:= TServiceManager.Create;
              ServiceManager.Connect;
finalization
              FreeAndNil( ServiceManager);
end.


