unit uOpenOfficeLog;

{                                                                             |
    Part of package pOpenOffice                                               |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See pOpenOffice.dpk for full copyright notice.                            |
|                                                                             }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComObj, Variants;


type
 TOpenOfficeLog
 =
  class
  private
    sl: TStringList;
    NomFichier: String;
    procedure Sauve;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Entree( S: String);
  end;

var
   OpenOfficeLog: TOpenOfficeLog= nil;

implementation

{ TOpenOfficeLog }

constructor TOpenOfficeLog.Create;
begin
     inherited;
     sl:= TStringList.Create;
     NomFichier:= ExtractFilePath( ParamStr(0))+'pOpenOffice.log.txt';
     if FileExists( NomFichier) then sl.LoadFromFile( NomFichier);
     sl.Add( '##############################################################');
     sl.Add( 'Dmarrage: '+FormatDateTime( 'dddddd", "tt', Now));
end;

destructor TOpenOfficeLog.Destroy;
begin
     sl.Add( '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
     Sauve;
     FreeAndNil( sl);
     inherited;
end;

procedure TOpenOfficeLog.Sauve;
begin
     sl.SaveToFile( NomFichier);
end;

procedure TOpenOfficeLog.Entree( S: String);
begin
     sl.Add( FormatDateTime( 'dddddd", "tt', Now));
     sl.Add( S);
     Sauve;
end;

initialization
              OpenOfficeLog:= TOpenOfficeLog.Create;
finalization
              FreeAndNil( OpenOfficeLog);
end.
