unit uUNO_DeskTop;
{                                                                             |
    Part of package pOpenOffice                                               |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See pOpenOffice.dpk for full copyright notice.                            |
|                                                                             }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComObj, Variants,

  uUNO_ServiceManager,

  uUNO_Object,

  uUNO_PropertyValue;

type
 TUNO_DeskTop
 =
  class( TUNO_Object)
  public
    constructor Create;
    function LoadComponentFromURL( URL, TargetFrameName: String;
                                   SearchFlags: LongInt;
                                   Arguments: Variant): Variant;
    function CreateDocument( URL: String; ReadOnly: Boolean;
                             AsTemplate: Boolean= True): Variant;
    function OpenFile( FileName: String;  ReadOnly: Boolean;
                       AsTemplate: Boolean= True): Variant;
    function CreateWriter: Variant;
    function CreateCalc  : Variant;
    function URL_from_WindowsFileName( FileName: String): String;
  end;

var
   UNO_DeskTop: TUNO_DeskTop;

implementation

{ TUNO_DeskTop }

constructor TUNO_DeskTop.Create;
begin
     UNO_ClassName:= 'com.sun.star.frame.Desktop';
     inherited Create;
end;

function TUNO_DeskTop.LoadComponentFromURL( URL, TargetFrameName: String;
                                        SearchFlags: Integer;
                                        Arguments: Variant): Variant;
begin
     Result:= ole.LoadComponentFromURL( URL, TargetFrameName,
                                        SearchFlags, Arguments);
end;

function TUNO_DeskTop.CreateDocument( URL: String; ReadOnly: Boolean;
                                      AsTemplate: Boolean= True): Variant;
var
   LoadParams: Variant;
   procedure SetBooleanProperty( index: Integer; Name: String; Value: Boolean);
   var
      PropertyValue: TUNO_PropertyValue;
   begin
        PropertyValue:= TUNO_PropertyValue.Create;
        try
           PropertyValue[ Name]:= Value;
           LoadParams[index]:= PropertyValue.ole;
        finally
               FreeAndNil( PropertyValue);
               end;
   end;
begin
     LoadParams:= VarArrayCreate([0, 1], varVariant);
     SetBooleanProperty( 0, 'ReadOnly'  , ReadOnly  );
     SetBooleanProperty( 1, 'AsTemplate', AsTemplate);
     Result:= LoadComponentFromURL( URL, '_blank', 0, LoadParams);
end;

function TUNO_DeskTop.OpenFile( FileName: String; ReadOnly: Boolean;
                                AsTemplate: Boolean= True): Variant;
var
   URL: String;
begin
     URL:= URL_from_WindowsFileName( FileName);
     Result:= CreateDocument( URL, ReadOnly, AsTemplate);
end;

function TUNO_DeskTop.CreateWriter: Variant;
begin
     Result:= CreateDocument( 'private:factory/swriter', False);
end;

function TUNO_DeskTop.CreateCalc: Variant;
begin
     Result:= CreateDocument( 'private:factory/scalc' , False);
end;

function TUNO_DeskTop.URL_from_WindowsFileName(FileName: String): String;
var
   I: Integer;
begin
     Result:= FileName;
     for I:= 0 to Length( Result)
     do
       if Result[I]= '\'
       then
           Result[I]:= '/';
     Result:= 'file:///'+Result;
end;

initialization
              UNO_DeskTop:= TUNO_DeskTop.Create;
finalization
              FreeAndNil( UNO_DeskTop);
end.
