unit uUNO_ServiceManager;
{                                                                             |
    Part of package pOpenOffice                                               |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See pOpenOffice.dpk for full copyright notice.                            |
|                                                                             }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComObj, Variants, ActiveX,

  uOpenOfficeLog(*,

  OOoTools*);

type
 TUNO_ServiceManager
 =
  class
  public
    ole: Variant;
    Connected: Boolean;
    constructor Create;
    destructor Destroy; override;

    function Connect: Boolean;
    procedure Disconnect;

    function CreateInstance( UNO_ClassName: String): Variant;
  end;

var
   UNO_ServiceManager: TUNO_ServiceManager = nil;

implementation

{ TUNO_ServiceManager }

constructor TUNO_ServiceManager.Create;
begin
     inherited Create;
     Connected:= False;
     Disconnect;
end;

destructor TUNO_ServiceManager.Destroy;
begin
     Disconnect;
     inherited;
end;

function TUNO_ServiceManager.Connect: Boolean;
const
     UNO_ServiceManager_OLE_Classname= 'com.sun.star.ServiceManager';
var
   MessageException: String;
begin
     if VarIsEmpty( ole)
     then
         try
            //ConnectOpenOffice;
            //ole:= OpenOffice;
            ole:= CreateOleObject(UNO_ServiceManager_OLE_Classname);
         except
               on E: Exception
               do
                 begin
                 MessageException
                 :=
                   'pOpenOffice.bpl :: TUNO_ServiceManager.Connect: '+
                   'Impossible de crer un objet '+UNO_ServiceManager_OLE_Classname+#13#10+
                   'Message de l''exception: '#13#10+
                   E.Message;
                 OpenOfficeLog.Entree( MessageException);
                 //MessageBox( 0, PChar( MessageException), 'Erreur', MB_ICONERROR or MB_OK);
                 //raise;
                 ole:= Null;
                 end;
               end;

     Connected:= not ( VarIsEmpty(ole) or VarIsNull (ole) );
     Result:= Connected;
     if not Result
     then
         OpenOfficeLog.Entree( 'Echec de TUNO_ServiceManager.Connect');
end;

procedure TUNO_ServiceManager.Disconnect;
begin
     VarClear( ole);
     Connected:= False;
end;

function TUNO_ServiceManager.CreateInstance( UNO_ClassName: String): Variant;
var
   MessageException: String;
begin
     VarClear( Result);
     if not Connected then exit;

     try
        Result:= ole.CreateInstance( UNO_ClassName);
     except
           on E: Exception
           do
             begin
             MessageException
             :=
               'pOpenOffice.bpl :: TUNO_ServiceManager.CreateInstance: '+
               'Impossible de crer un objet UNO '+UNO_ClassName+#13#10+
               'Message de l''exception: '#13#10+
               E.Message;
             OpenOfficeLog.Entree( MessageException);
             MessageBox( 0, PChar( MessageException), 'Erreur', MB_ICONERROR or MB_OK);
             raise;
             end;
           end;
     if    VarIsEmpty( Result)
        or VarIsNull ( Result)
        or VarIsClear( Result)
     then
         OpenOfficeLog.Entree( 'Echec de TUNO_ServiceManager.CreateInstance');
end;

initialization
              CoInitialize( nil);
              UNO_ServiceManager:= TUNO_ServiceManager.Create;
              UNO_ServiceManager.Connect;
finalization
              FreeAndNil( UNO_ServiceManager);
end.


