unit utcOOoDatasetPrinter;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils, Classes, DB, DBClient,
  TestFrameWork,
  utcOOoTestCase,
  uOOoDatasetPrinter;

type
 TtcOOoDatasetPrinter
 =
  class( TtcOOoTestCase)
  private
  // Test methods
  published
    procedure TestExecute;
    procedure TestExecuteModele;
    procedure TestAssureModele;
    procedure TestExecuteModele_SurTitre_Nil;
  end;

implementation

{ TtcOOoDatasetPrinter }

procedure TtcOOoDatasetPrinter.TestExecute;
begin
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDatasetPrinter.Execute( cd);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDatasetPrinter.TestAssureModele;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDatasetPrinter_AssureModele.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDatasetPrinter.AssureModele( NomFichier, cd);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDatasetPrinter.TestExecuteModele;
var
   NomFichier: String;
   F: Variant;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDatasetPrinter.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        F:= OOoDatasetPrinter.Execute( NomFichier, 'TtcOOoDatasetPrinter.TestExecuteModele;', cd, OOoSurTitre);
        F.Close( True);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDatasetPrinter.TestExecuteModele_SurTitre_Nil;
var
   NomFichier: String;
   F: Variant;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDatasetPrinter.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        F:= OOoDatasetPrinter.Execute( NomFichier, 'TtcOOoDatasetPrinter.TestExecuteModele;', cd, nil);
        F.Close( True);
     finally
            Detruit_Dataset;
            end;
end;

initialization

  TestFramework.RegisterTest('utcOOoDatasetPrinter Suite',
    TtcOOoDatasetPrinter.Suite);

end.
