unit utcOOoDatasetRowPrinter;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils, Classes, DB, DBClient,Variants,
  TestFrameWork,
  utcOOoTestCase,
  uUNO_DeskTop,
  uOOoTextFieldsCreator,
  uOOoDatasetRowPrinter;

type
 TtcOOoDatasetRowPrinter
 =
  class(TtcOOoTestCase)
  // Test methods
  published
    procedure TestAssureModele;
    procedure TestAssureModele_Mise_a_jour;
    procedure TestExecute;
    procedure TestExecute_for_each_row;
  end;

implementation

{ TtcOOoDatasetRowPrinter }

procedure TtcOOoDatasetRowPrinter.TestAssureModele;
var
   NomFichierModele: String;
begin
     NomFichierModele:= ExtractFilePath( ParamStr(0))+'OOoDatasetRowPrinter_AssureModele.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDatasetRowPrinter.AssureModele( NomFichierModele, cd);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDatasetRowPrinter.TestAssureModele_Mise_a_jour;
var
   NomFichierModele: String;
   F: Variant;
   Trouve: Boolean;
   Fieldname: String;
begin
     NomFichierModele
     :=
       ExtractFilePath( ParamStr(0))+'OOoDatasetRowPrinter_AssureModele_Mise_a_jour.ott';
     if FileExists( NomFichierModele)
     then
         DeleteFile( NomFichierModele);

     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        Fieldname:= OOoTextFieldsCreator.OOoFieldName_from_DisplayLabel( cd.Fields[0].DisplayLabel);

        //cration d'un modle vide
        F:= UNO_DeskTop.CreateWriter;
        F.storeAsURL( UNO_DeskTop.URL_from_WindowsFileName( NomFichierModele),
                      VarArrayOf([]));
        Trouve:= OOoTextFieldsCreator.Existe( F, Fieldname);
        Check( not Trouve, 'Le champ '+Fieldname+'existe dj dans '+NomFichierModele);
        F.dispose;

        //Mise  jour du modle
        OOoDatasetRowPrinter.AssureModele( NomFichierModele, cd, True);

        //contrle
        F:= UNO_DeskTop.OpenFile( NomFichierModele, False, False);
        Trouve:= OOoTextFieldsCreator.Existe( F, Fieldname);
        Check( Trouve, 'Le champ '+Fieldname+'n''a pas t cr dans '+NomFichierModele);
        F.dispose;
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDatasetRowPrinter.TestExecute;
var
   NomFichier: String;
   F: Variant;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDatasetRowPrinter.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        F:= OOoDatasetRowPrinter.Execute( NomFichier, cd, False);
        F.Close( True);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDatasetRowPrinter.TestExecute_for_each_row;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDatasetRowPrinter.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDatasetRowPrinter.Execute_for_each_row( NomFichier, cd);
     finally
            Detruit_Dataset;
            end;
end;

initialization

  TestFramework.RegisterTest('utcOOoDatasetRowPrinter Suite',
    TtcOOoDatasetRowPrinter.Suite);

end.
