unit utcOOoDetailPrinter;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils, Classes, DB, DBClient,
  TestFrameWork,
  utcOOoTestCase,
  uOOoDetailPrinter;

type
 TtcOOoDetailPrinter
 =
  class( TtcOOoTestCase)
  // Test methods
  published
    procedure TestAssureModele;
    procedure TestExecute;
  end;

implementation

{ TtcOOoDetailPrinter }

procedure TtcOOoDetailPrinter.TestAssureModele;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDetail_AssureModele.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDetailPrinter.AssureModele( NomFichier, ['truc'], cd, cd);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDetailPrinter.TestExecute;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDetail.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDetailPrinter.Execute( NomFichier,
                                   'TtcOOoDetail.TestExecuteModele;',
                                   ['truc'],['troc'], cd, cd, OOoSurTitre);
     finally
            Detruit_Dataset;
            end;
end;

initialization
  TestFramework.RegisterTest('utcOOoDetailPrinter Suite',
    TtcOOoDetailPrinter.Suite);

end.
