unit utcOOoDetailStringGridPrinter;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils, Classes, DB, DBClient, Grids,
  TestFrameWork,
  utcOOoTestCase,
  uOOoDetailStringGridPrinter;

type
 TtcOOoDetailStringGridPrinter
 =
  class( TtcOOoTestCase)
  private
    sg: TStringGrid;
  protected
    procedure SetUp; override;
    procedure TearDown; override;
  published
    // Test methods
    procedure TestAssureModele;
    procedure TestExecute;
  end;

implementation

{ TtcOOoDetailStringGridPrinter }

procedure TtcOOoDetailStringGridPrinter.SetUp;
var
   I, J: Integer;
begin
     inherited;
     sg:= TStringGrid.Create( nil);
     sg.Name:= 'troc';
     sg.ColCount:= 5;
     sg.RowCount:= 5;

     for I:= 0 to 4
     do
       for J:= 0 to 4
       do
         sg.Cells[I, J]:= Format( 'Cellule (%d,%d)', [I, J]);
end;

procedure TtcOOoDetailStringGridPrinter.TearDown;
begin
     FreeAndNil( sg);
     inherited;
end;

procedure TtcOOoDetailStringGridPrinter.TestAssureModele;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDetailStringGridPrinter_AssureModele.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        OOoDetailStringGridPrinter.AssureModele( NomFichier, ['truc'], cd, sg);
     finally
            Detruit_Dataset;
            end;
end;

procedure TtcOOoDetailStringGridPrinter.TestExecute;
var
   NomFichier: String;
   F: Variant;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoDetailStringGridPrinter.ott';
     cd:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        F:= OOoDetailStringGridPrinter.Execute( NomFichier,
                             'TtcOOoDetailStringGridPrinter.TestExecute;',
                             ['truc'],['troc'],
                             cd, sg);
        F.Close( True);
        sg.Cells[0,0]:= FormatDateTime( 'dddddd","tt',Now);
        F:= OOoDetailStringGridPrinter.Execute( NomFichier,
                             'TtcOOoDetailStringGridPrinter.TestExecute;',
                             ['truc'],['troc'],
                             cd, sg, OOoSurTitre);
        F.Close( True);
     finally
            Detruit_Dataset;
            end;
end;

initialization

  TestFramework.RegisterTest('utcOOoDetailStringGridPrinter Suite',
    TtcOOoDetailStringGridPrinter.Suite);

end.
