unit utcOOoMultiDetailPrinter;
{                                                                             |
    Part of program OpenOfficeTests                                           |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See OpenOfficeTests.dpr for full copyright notice.                        |
|                                                                             }

interface

uses
  SysUtils, Classes, DB, DBClient,
  TestFrameWork,
  utcOOoTestCase,
  uOOoMultiDetailPrinter;

type
 TtcOOoMultiDetailPrinter
 =
  class( TtcOOoTestCase)
  private
    cd2: TClientDataset;
  // Test methods
  published
    procedure TestAssureModele;
    procedure TestExecute;
  end;

implementation

{ TtcOOoMultiDetailPrinter }

procedure TtcOOoMultiDetailPrinter.TestAssureModele;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoMultiDetail_AssureModele.ott';
     cd := TClientDataset.Create( nil);
     cd2:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        Cree_dataset_interne( cd2, 'cd2');
        OOoMultiDetailPrinter.AssureModele( NomFichier, ['truc'], cd, [cd, cd2]);
     finally
            Detruit_Dataset;
            FreeAndNil( cd2);
            end;
end;

procedure TtcOOoMultiDetailPrinter.TestExecute;
var
   NomFichier: String;
begin
     NomFichier:= ExtractFilePath( ParamStr(0))+'OOoMultiDetail.ott';
     cd := TClientDataset.Create( nil);
     cd2:= TClientDataset.Create( nil);
     try
        Cree_dataset;
        Cree_dataset_interne( cd2, 'cd2');
        OOoMultiDetailPrinter.Execute( NomFichier,
                                   'TtcOOoMultiDetail.TestExecuteModele;',
                                   ['truc'],['troc'], cd, [cd, cd2],
                                   [OOoSurTitre, nil],[nil,nil]);
     finally
            Detruit_Dataset;
            FreeAndNil( cd2);
            end;
end;

initialization
  TestFramework.RegisterTest('utcOOoMultiDetailPrinter Suite',
    TtcOOoMultiDetailPrinter.Suite);

end.
