unit uOOoDatasetPrinter;
{                                                                             |
    Part of package pOpenOfficeReport                                         |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See pOpenOfficeReport.dpk for full copyright notice.                      |
|                                                                             }

interface

uses
    SysUtils, Classes, DB, Variants,
    uUNO_ControlCharacter,
    uUNO_DeskTop,
    uUNO_BookMark,
    uUNO_FieldMaster_User,
    uUNO_TextField_User,
    uUNO_TextTable,
    uOOoSurTitre;

type
 TOOoDatasetPrinter
 =
  class
  public
    function Execute( D: TDataset): Variant; overload;

    procedure AssureModele( NomFichierModele: String; D: TDataset);
    function Execute( NomFichierModele, sTitreEtat: String; D: TDataset;
                      OOoSurTitre: TOOoSurTitre = nil): Variant; overload;
  end;

var
   OOoDatasetPrinter: TOOoDatasetPrinter= nil;

implementation

uses
    uOOoTextFieldsCreator,
    uOOoTextTableManager;

const
     s_Titre= 'OOoDatasetPrinter_Titre';

{ TOOoDatasetPrinter }


function TOOoDatasetPrinter.Execute( D: TDataset): Variant;
var
   F: Variant;
begin
     F:= UNO_DeskTop.CreateWriter;

     OOoTextTableManager.Execute_Modele( F, D, True);
     OOoTextTableManager.Remplit( F, D);

     Result:= F;
end;

procedure TOOoDatasetPrinter.AssureModele( NomFichierModele: String; D: TDataset);
var
   NouveauModele: Boolean;

   URLModele: String;

   F: Variant;
begin
     NouveauModele:= not FileExists( NomFichierModele);

     URLModele:= UNO_DeskTop.URL_from_WindowsFileName( NomFichierModele);

     if NouveauModele
     then
         F:= UNO_DeskTop.CreateWriter
     else
         F:= UNO_DeskTop.OpenFile( NomFichierModele, False, False);

     //champ Titre
     OOoTextFieldsCreator.Execute_Modele( F, s_Titre, NouveauModele);

     //table du dataset
     OOoTextTableManager.Execute_Modele( F, D, NouveauModele);

     F.storeAsURL( URLModele, VarArrayOf([]));
     F.Close( True);
end;

function TOOoDatasetPrinter.Execute( NomFichierModele, sTitreEtat: String;
                                     D: TDataset;
                                     OOoSurTitre: TOOoSurTitre = nil): Variant;
var
   F: Variant;
begin
     if ExtractFilePath( NomFichierModele) = ''
     then
         NomFichierModele:= ExtractFilePath( ParamStr(0))+ NomFichierModele;

     AssureModele( NomFichierModele, D);

     F:= UNO_DeskTop.OpenFile( NomFichierModele, False);

     //champ Titre
     OOoTextFieldsCreator.Execute( F, s_Titre, sTitreEtat);

     //table du dataset
     OOoTextTableManager.Remplit(F,D, OOoSurTitre);

     Result:= F;
end;

initialization
              OOoDatasetPrinter:= TOOoDatasetPrinter.Create;
finalization
              FreeAndNil( OOoDatasetPrinter);
end.
