unit uOOoMultiDetailPrinter;
{                                                                             |
    Part of package pOpenOfficeReport                                         |
                                                                              |
    Author: Jean SUZINEAU <Jean.Suzineau@wanadoo.fr>                          |
            partly as freelance: http://www.mars42.com                        |
        and partly as employee : http://www.batpro.com                        |
    Contact: gilles.doutre@batpro.com                                         |
                                                                              |
    Copyright (C) 2004  Jean SUZINEAU - MARS42                                |
    Copyright (C) 2004  Cabinet Gilles DOUTRE - BATPRO                        |
                                                                              |
    See pOpenOfficeReport.dpk for full copyright notice.                      |
|                                                                             }

interface

uses
    SysUtils, Classes, DB,Variants, Dialogs,
    uUNO_ControlCharacter,
    uUNO_DeskTop,
    uUNO_BookMark,
    uUNO_FieldMaster_User,
    uUNO_TextField_User,
    uUNO_TextTable,
    uOOoSurTitre,
    uOOoMerge;

type
 TOOoMultiDetailPrinter
 =
  class
  public
    procedure AssureModele( NomFichierModele: String;
                            ParametresNoms: array of string;
                            Maitre: TDataset;
                            Details: array of TDataset);
    function Execute( NomFichierModele, sTitreEtat: String;
                      ParametresNoms,
                      ParametresValeurs: array of string;
                      Maitre: TDataset;
                      Details     : array of TDataset;
                      OOoSurTitres: array of TOOoSurTitre;
                      OOoMerge    : array of TOOoMerge   ): Variant; overload;
  end;

var
   OOoMultiDetailPrinter: TOOoMultiDetailPrinter= nil;

implementation

uses
    uOOoTextFieldsCreator,
    uOOoTextTableManager;

const
     s_Titre= 'OOoMultiDetailPrinter_Titre';

{ TOOoMultiDetailPrinter }

procedure TOOoMultiDetailPrinter.AssureModele( NomFichierModele: String;
                                               ParametresNoms: array of string;
                                               Maitre: TDataset;
                                               Details: array of TDataset);
var
   I, Longueur: Integer;

   NouveauModele: Boolean;

   URLModele: String;

   F: Variant;
begin
     NouveauModele:= not FileExists( NomFichierModele);

     URLModele:= UNO_DeskTop.URL_from_WindowsFileName( NomFichierModele);

     if NouveauModele
     then
         F:= UNO_DeskTop.CreateWriter
     else
         F:= UNO_DeskTop.OpenFile( NomFichierModele, False, False);

     //champ Titre
     OOoTextFieldsCreator.Execute_Modele( F, s_Titre, NouveauModele);

     //Paramtres
     Longueur:= Length( ParametresNoms);
     if Longueur <> 0
     then
         for I:= 0 to Longueur-1
         do
           OOoTextFieldsCreator.Execute_Modele( F, ParametresNoms[I],
                                                NouveauModele);
     //champs du dataset maitre
     OOoTextFieldsCreator.Execute_Modele( F, Maitre , NouveauModele);

     //table du dataset dtail
     for I:= Low( Details) to High( Details)
     do
       OOoTextTableManager.Execute_Modele( F, Details[I], NouveauModele);

     F.storeAsURL( URLModele, VarArrayOf([]));
     F.Dispose;
end;

function TOOoMultiDetailPrinter.Execute( NomFichierModele, sTitreEtat: String;
                                         ParametresNoms,
                                         ParametresValeurs: array of string;
                                         Maitre: TDataset;
                                         Details: array of TDataset;
                                         OOoSurTitres: array of TOOoSurTitre;
                                         OOoMerge: array of TOOoMerge): Variant;
var
   I, Longueur: Integer;
   F: Variant;
begin
     if ExtractFilePath( NomFichierModele) = ''
     then
         NomFichierModele:= ExtractFilePath( ParamStr(0))+ NomFichierModele;

     AssureModele( NomFichierModele, ParametresNoms, Maitre, Details);

     F:= UNO_DeskTop.OpenFile( NomFichierModele, False);

     //champ Titre
     OOoTextFieldsCreator.Execute( F, s_Titre, sTitreEtat);

     //Paramtres
     Longueur:= Length( ParametresNoms);
     if Longueur <> 0
     then
         for I:= 0 to Longueur-1
         do
           OOoTextFieldsCreator.Execute( F, ParametresNoms[I], ParametresValeurs[I]);

     //champs du dataset maitre
     OOoTextFieldsCreator.Execute( F, Maitre);

     //table du dataset dtail
     for I:= Low( Details) to High( Details)
     do
       OOoTextTableManager.Remplit( F, Details[I], OOoSurTitres[I], OOoMerge[I]);

     Result:= F;
end;


initialization
              OOoMultiDetailPrinter:= TOOoMultiDetailPrinter.Create;
finalization
              FreeAndNil( OOoMultiDetailPrinter);
end.
